<HEAD>
<TITLE>Virtual Reality - LaValle</TITLE>
</HEAD>

<body bgcolor="#ffffff">

<img align=left src="AnnaCoverBlue2.jpg" width="200">

<h1>&nbsp;VIRTUAL REALITY</h1>

<p>

&nbsp;&nbsp;&nbsp;<b>By <a href="http://msl.cs.uiuc.edu/~lavalle/">Steven M. LaValle</a></b>.  To be published by <b>Cambridge University Press</b>.<br>
<p>

&nbsp;&nbsp;&nbsp;This free VR book covers the fundamentals of virtual reality systems, including geometric modeling, transformations, graphical rendering, optics, the human vision, auditory, and vestibular systems, tracking systems, interface design, human factors, developer recommendations, and technological issues.


<p>

Free VR lectures on <a href="https://www.youtube.com/playlist?list=PLbMVogVj5nJSyt80VRXYC-YrAvQuUb6dh">YouTube</a>.  These are part of an accompanying <a href="http://nptel.ac.in/courses/106106138/">MOOC (free on-line course)</a>, produced by NPTEL and IIT Madras, 2016</a>. 

<p>

Why did I write this?  Click <a href="motivation.html">here</a>. Feel free to send feedback and corrections (I will acknowledge you in the final version).

<p>

<a HREF="book.html">The whole book in HTML</a><br>


<small>Book cover art by <a href="http://msl.cs.uiuc.edu/~yershova/">Anna Yershova</a>.</small>

<BR clear=all>

<p>

<hr>

<h3>Download the whole book</h3>

<p>
 
<a HREF="vrbook.pdf">[pdf file]</a> -- Two pages per one.  Recommended for printing on US Letter paper.<br>
<a HREF="vrbooka4.pdf">[pdf file]</a> -- Two pages per one.  Recommended for printing on A4 paper<br>
<a HREF="vrbookbig.pdf">[pdf file]</a> -- One page per one (larger print).  May be easier for on-line viewing.<br>
<p>

<hr>

<h3>Download chapters</h3> 

<p>

<TABLE BORDER COLS=2 WIDTH="100%" NOSAVE >
<TR>


</TR>

<tr><TD>CHAPTER</TD><td>LAST UPDATE</td><td>TOPICS</td></tr>
<tr><TD>Chapter 1: Introduction <a href="vrch1.pdf"><br>[pdf]</a></TD>
    <td>13 Mar 2019</td>
    <TD>Definition of VR, modern experiences, historical perspective.
    </TD>
</tr>

<tr><TD>Chapter 2: Bird's Eye View <a href="vrch2.pdf"><br>[pdf]</TD>
    <td>13 Mar 2019</td>
    <TD>Hardware, sensors, displays, software, virtual world generator, game engines, human senses, perceptual psychology, psychophysics.
    </TD>
</tr>

<tr><TD>Chapter 3: The Geometry of Virtual Worlds<a href="vrch3.pdf"><br>[pdf]</TD>
    <td>13 Mar 2019</td>
    <TD>Geometric modeling, transforming rigid bodies, yaw, pitch, roll, axis-angle representation, quaternions, 3D rotation inverses and conversions, homogeneous transforms, transforms to displays, look-at and eye transforms, canonical view and perspective transforms, viewport transforms.
    </TD>
</tr>

<tr><TD>Chapter 4: Light and Optics<a href="vrch4.pdf"><br>[pdf]</TD>
    <td>13 Mar 2019</td>
    <TD>Light propagation, lenses and images, diopters, spherical aberrations, optical distortion; more lens aberrations; spectral properties; the eye as an optical system; cameras; visual displays.
    </TD>
</tr>

<tr><TD>Chapter 5: The Physiology of Human Vision<a href="vrch5.pdf"><br>[pdf]</TD>
    <td>13 Mar 2019</td>
    <TD>Parts of the human eye, photoreceptors and densities, scotopic and photopic vision, display resolution requiments, eye movements, neural vision structures, sufficient display resolution, other implications of physiology on VR.
    </TD>
</tr>

<tr><TD>Chapter 6: Visual Perception<a href="vrch6.pdf"><br>[pdf]</TD>
    <td>13 Mar 2019</td>
    <TD>Depth perception, motion perception, vection, stroboscopic apparent motion, color perception, combining information from multiple cues and senses, implications of perception on VR.
    </TD>
</tr>

<tr><TD>Chapter 7: Visual Rendering<a href="vrch7.pdf"><br>[pdf]</TD>
    <td>13 Mar 2019</td>
    <TD>Graphical rendering, ray tracing, shading, BRDFs, rasterization, barycentric coordinates, VR rendering problems, anti-aliasing, distortion shading, image warping (time warp), panoramic rendering.
    </TD>
</tr>

<tr><TD>Chapter 8: Motion in Real and Virtual Worlds<a href="vrch8.pdf"><br>[pdf]</TD>
    <td>13 Mar 2019</td>
    <TD>Velocities, acceleration, vestibular system, virtual world physics, simulation, collision detection, avatar motion, vection.
    </TD>
</tr>

<tr><TD>Chapter 9: Tracking<a href="vrch9.pdf"><br>[pdf]</TD>
    <td>13 Mar 2019</td>
    <TD>Tracking systems, estimating rotation, IMU integration, drift errors, tilt and yaw correction, estimating position, camera-feature detection model, perspective n-point problem, sensor fusion, lighthouse approach, attached bodies, eye tracking, inverse kinematics, map building, SLAM.
    </TD>
</tr>

<tr><TD>Chapter 10: Interaction<a href="vrch10.pdf"><br>[pdf]</TD>
    <td>13 Mar 2019</td>
    <TD>Remapping, locomotion, manipulation, social interaction, specialized interaction mechanisms.
    </TD>
</tr>

<tr><TD>Chapter 11: Audio<a href="vrch11.pdf"><br>[pdf]</TD>
    <td>13 Mar 2019</td>
    <TD>Sound propagation, ear physiology, auditory perception, auditory localization; Fourier analysis; acoustic modeling, HRTFs, rendering, auralization.
    </TD>
</tr>

<tr><TD>Chapter 12: Evaluating VR Systems and Experiences<a href="vrch12.pdf"><br>[pdf]</TD>
    <td>13 Mar 2019</td>
    <TD>Perceptual training, recommendations for developers, best practices, VR sickness, experimental methods that involve human subjects.
    </TD>
</tr>

<tr><TD>Chapter 13: Frontiers<a href="vrch13.pdf"><br>[pdf]</TD>
    <td>13 Mar 2019</td>
    <TD>Touch, haptics, taste, smell, robotic interfaces, telepresence, brain-machine interfaces.
    </TD>
</tr>

</TABLE>

<p>

<hr>

<h3>Related resources</h3> 

VR lectures and course materials appear below from the course at the University of Illinois.  It was taught by Steve LaValle in Spring 2015, 2016, 2017 and Anna Yershova in Fall 2015, 2016, 2017 and Spring 2018.

<ul>
<li><a href="https://courses.engr.illinois.edu/cs498sl/">VR class</a> web page from the University of Illinois (course developers: Steve LaValle and Anna Yershova).
<li>Hand-written <a href="notebookc.pdf">VR lecture notes</a> from Spring 2015.
<li>Steve LaValle's <a href="http://nptel.ac.in/courses/106106138/">recorded VR lectures</a> from NPTEL at IIT Madras, July 2015.
<li>Anna Yershova's <a href="https://courses.engr.illinois.edu/cs498sl3/calendar.php">VR lecture slides</a>.
</ul>



